////////////////////////////////////////////////////////////////////////
// timers.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.timers")

// <%pre>
#line 1 "timers.ecpp"


#include <timers.h>
#include <tools.h>
#include <setup.h>
#include <epg_events.h>
#include <timerconflict.h>
#include <livefeatures.h>
#include <users.h>

using namespace vdrlive;

static const size_t maximumDescriptionLength = 300;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class timer_actions_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        timer_actions_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    timer_actions_type timer_actions;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("timers");

static const char* rawData = "\364\000\000\000\030\001\000\000#\001\000\000&\001\000\000l\001\000\000o\001\000\000\207"
  "\001\000\000\213\001\000\000\214\001\000\000\307\001\000\000\006\002\000\000b\002\000\0001\003\000\000^\003\000\000"
  "\213\003\000\000\270\003\000\000\345\003\000\000\022\004\000\000T\005\000\000u\005\000\000\201\005\000\000\212\005"
  "\000\000\247\005\000\000\340\005\000\000\342\005\000\000\002\006\000\000#\006\000\000\?\006\000\000`\006\000\000|\006"
  "\000\000\231\006\000\000\237\006\000\000\240\006\000\000\247\006\000\000\315\006\000\000\347\006\000\000&\007\000\000"
  "A\007\000\000i\007\000\000u\007\000\000\247\007\000\000\251\007\000\000\271\007\000\000\327\007\000\000\366\007\000"
  "\000\020\010\000\000\031\010\000\000O\010\000\000Q\010\000\000~\010\000\000\235\010\000\000\267\010\000\000\300\010"
  "\000\000\333\010\000\000\001\t\000\000\002\t\000\000\003\t\000\000\035\t\000\000\"\t\000\000[\t\000\000`\t\000\000\n<"
  "html>\n\t<head>\n\t\t<title>VDR-Live - </title>\n\t\t\n\t\t\n\t</head>\n\t<body onload=\"adjustHeader()\" onresize=\""
  "adjustHeader()\">\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t\t\n\t\t\t<table class=\"listing\" cellspacing=\"0\""
  " cellpadding=\"0\">\n\t\t\t\t\t\t<tr class=\"spacer\">\n\t\t\t\t\t\t\t<td colspan=\"8\"/>\n\t\t\t\t\t\t</tr>\n\t\t\t"
  "\t<tr class=\"head\">\n\t\t\t\t\t<td colspan=\"10\">\n\t\t\t\t\t\t<div class=\"boxheader\"><div><div>\n\t\t\t\t\t\t\t"
  "\n\t\t\t\t\t\t</div></div></div>\n\t\t\t\t\t</td>\n\t\t\t\t</tr>\n\t\t\t\t<tr class=\"description\">\n\t\t\t\t\t<td c"
  "lass=\"leftcol\"><img src=\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" /></td>\n\t\t\t\t\t<td><div"
  " class=\"withmargin\"></div></td>\n\t\t\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t\t\t\t<td><div class=\"wi"
  "thmargin\"></div></td>\n\t\t\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t\t\t\t<td><div class=\"withmargin\">"
  "</div></td>\n\t\t\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t\t\t\t<td class=\"action\"><img src=\"img/trans"
  "parent.png\" alt=\"\" width=\"16px\" height=\"16px\" /></td>\n\t\t\t\t\t<td class=\"action\"><img src=\"img/transpare"
  "nt.png\" alt=\"\" width=\"16px\" height=\"16px\" /></td>\n\t\t\t\t\t<td class=\"action rightcol\"><img src=\"img/tran"
  "sparent.png\" alt=\"\" width=\"16px\" height=\"16px\" /></td>\n\t\t\t\t</tr>\n\t\t\t\t<tr>\n\n\t\t\t\t<td class=\"lef"
  "tcol \"><img src=\"\" alt=\"\" ></img></td>\n\t\t\t\t\t<td class=\"\"><div class=\"withmargin\"><a href=\"schedule.ht"
  "ml\?channel=\"></a></div></td>\n\t\t\t\t\t<td class=\"\"><div class=\"withmargin nowrap\"></div></td>\n\t\t\t\t\t<td "
  "class=\"\"><div class=\"withmargin nowrap\"></div></td>\n\t\t\t\t\t<td class=\"\"><div class=\"withmargin\"><a\n\t\t"
  "\t\t\t\t\n\t\t\t\t\t\t></a></div>\n\t\t\t\t\t</td>\n\t\t\t\t\t<td class=\"\"><div class=\"withmargin\"></div></td>\n "
  "                                       <td class=\"\"><div class=\"withmargin\">\n                                   "
  "     </div></td>\n\t\t\t\t\t<a href=\"edit_searchtimer.html\?searchtimerid=\"></a></div></td>\n\t\t\t\t        <td cl"
  "ass=\"action \"><a href=\"timers.html\?timerid=&action=toggle\"><img src=\"\" alt=\"\" ></img></a></td>\n\t\t\t      "
  "          <td class=\"action \"></td>\n\t\t\t\t        <td class=\"action rightcol \"><a href=\"timers.html\?timerid="
  "&action=delete\"><img src=\"\" alt=\"\" ></img></a></td>\n\t\t\t\t</tr>\n\t\t\t</table>\n\t\t</div>\n\t</body>\n</htm"
  "l>\n\n\n<a href=\"edit_timer.html\"></a>\n<span class=\"sep\">|</span>\n<a href=\"timerconflicts.html\"></a>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    timer_actions(*this, "timer_actions")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("timers " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string timerid = qparam.get< std::string >("timerid");
std::string action = qparam.get< std::string >("action");
  // </%args>

#line 22 "timers.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 25 "timers.ecpp"
  typedef const cTimer* timer_type;
  TNT_REQUEST_PAGE_VAR(const cTimer*, timer, ());   // <%request> const cTimer* timer
  _tnt_ignore_unused<timer_type>(timer);
#line 26 "timers.ecpp"
  typedef TimerConflictNotifier timerNotifier_type;
  TNT_REQUEST_PAGE_VAR(TimerConflictNotifier, timerNotifier, ());   // <%request> TimerConflictNotifier timerNotifier
  _tnt_ignore_unused<timerNotifier_type>(timerNotifier);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 29 "timers.ecpp"

	if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

	pageTitle = trVDR("Timers");

	cMutexLock timersLock( &LiveTimerManager() );
	SortedTimers& timers = LiveTimerManager().GetTimers();

	timer = 0;
	if ( !timerid.empty() ) {
		std::string tId = SortedTimers::DecodeDomId(timerid);
//		dsyslog("live: DEBUG: TIMER: tId = %s", tId.c_str());
		timer = timers.GetByTimerId(tId);
		if ( timer == 0 )
			throw HtmlError( tr("Couldn't find timer. Maybe you mistyped your request?") );
		if (action == "delete") {
			if (!cUser::CurrentUserHasRightTo(UR_DELTIMERS))
				throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
//                        dsyslog("live: timers.ecpp timer->Id() %d", timer->Id());
//                        dsyslog("live: timers.ecpp timer->Remote() %s", timer->Remote());
			LiveTimerManager().DelTimer(timer->Id(), timer->Remote());
			timerNotifier.SetTimerModification();
			return reply.redirect("timers.html");
		}
		if (action == "toggle") {
			LiveTimerManager().ToggleTimerActive(timer->Id(), timer->Remote());
			timerNotifier.SetTimerModification();
			return reply.redirect("timers.html");
		}
	}

	std::string previousDay = "";

  // <& pageelems.doc_type ...
  { 
#line 62 "timers.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 62 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[0]; // \n<html>\n\t<head>\n\t\t<title>VDR-Live - 
#line 65 "timers.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 66 "timers.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 66 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 67 "timers.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 67 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n\t</head>\n\t<body onload="adjustHeader()" onresize="adjustHeader()">\n\t\t
  // <& pageelems.logo ...
  { 
#line 70 "timers.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 70 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n\t\t
  // <& menu ...
  { 
#line 71 "timers.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 71 "timers.ecpp"
    _tnt_cq4.add( "active", ("timers"));
#line 71 "timers.ecpp"
    _tnt_cq4.add( "component", ("timers.timer_actions"));
#line 71 "timers.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n\t\t<div class="inhalt">\n
#line 73 "timers.ecpp"

		#ifdef DEBUG_LOCK
                        dsyslog("live: pages/timers.ecpp LOCK_TIMERS_READ");
                #endif
		        LOCK_TIMERS_READ;
                        cSortedTimers sortedTimers(Timers);
			if (sortedTimers.Size() == 0) {

  reply.out() << _tntChunks[6]; // \t\t\t\t
#line 81 "timers.ecpp"
  reply.sout() << ( tr("No timer defined") );
  reply.out() << _tntChunks[7]; // \n
#line 82 "timers.ecpp"
			} else {

  reply.out() << _tntChunks[8]; // \t\t\t<table class="listing" cellspacing="0" cellpadding="0">\n
#line 84 "timers.ecpp"

				// output of the timer list:
                                for (int i = 0; i < sortedTimers.Size(); i++) {
                                        const cTimer *timer = sortedTimers[i];
	                 		EpgInfoPtr epgEvent;
					std::string longDescription;
					std::string searchTimName;
					std::string searchTimId;

					if (timer->Event())
					{
						epgEvent = EpgEvents::CreateEpgInfo(timer->Channel(), timer->Event());
						longDescription = StringEscapeAndBreak(SortedTimers::GetTimerInfo(*timer)) + "<hr>"
											+ StringEscapeAndBreak(StringWordTruncate(epgEvent->LongDescr(), maximumDescriptionLength))
											+ "<br/><br/>" + tr("Click to view details.");
						searchTimName = SortedTimers::SearchTimerInfo(*timer, "searchtimer");
						searchTimId = SortedTimers::SearchTimerInfo(*timer, "s-id");
					}
					std::string currentDay = SortedTimers::GetTimerDays(timer);
                                        const cTimer *nextTimer =  NULL;
                                        if (i < (sortedTimers.Size() - 1)) nextTimer = sortedTimers[i + 1];
					bool bottom = false;
					if (i == sortedTimers.Size() - 1) bottom = true;
					else {
						std::string nextDay = SortedTimers::GetTimerDays(nextTimer);
						bottom = (currentDay != nextDay);
					}
					if (previousDay != currentDay) {
						if (!previousDay.empty()) {

  reply.out() << _tntChunks[9]; // \t\t\t\t\t\t<tr class="spacer">\n\t\t\t\t\t\t\t<td colspan="8"/>\n\t\t\t\t\t\t</tr>\n
#line 117 "timers.ecpp"

						}
						previousDay = currentDay;

  reply.out() << _tntChunks[10]; // \t\t\t\t<tr class="head">\n\t\t\t\t\t<td colspan="10">\n\t\t\t\t\t\t<div class="boxheader"><div><div>\n\t\t\t\t\t\t\t
#line 124 "timers.ecpp"
  reply.sout() << ( currentDay );
  reply.out() << _tntChunks[11]; // \n\t\t\t\t\t\t</div></div></div>\n\t\t\t\t\t</td>\n\t\t\t\t</tr>\n\t\t\t\t<tr class="description">\n\t\t\t\t\t<td class="leftcol"><img src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 130 "timers.ecpp"
  reply.sout() << ( trVDR("Channel") );
  reply.out() << _tntChunks[12]; // </div></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 131 "timers.ecpp"
  reply.sout() << ( trVDR("Start") );
  reply.out() << _tntChunks[13]; // </div></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 132 "timers.ecpp"
  reply.sout() << ( trVDR("Stop") );
  reply.out() << _tntChunks[14]; // </div></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 133 "timers.ecpp"
  reply.sout() << ( trVDR("File") );
  reply.out() << _tntChunks[15]; // </div></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 134 "timers.ecpp"
  reply.sout() << ( trVDR("Record on") );
  reply.out() << _tntChunks[16]; // </div></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 135 "timers.ecpp"
  reply.sout() << ( tr("Searchtimer") );
  reply.out() << _tntChunks[17]; // </div></td>\n\t\t\t\t\t<td class="action"><img src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t<td class="action"><img src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t<td class="action rightcol"><img src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t</tr>\n
#line 140 "timers.ecpp"

					}
					std::string timerStateImg = "transparent.png";
					std::string timerStateHint;
					if (timer->Recording()) {
						timerStateImg = "arrow_rec.gif";
						timerStateHint = tr("Timer is recording.");
					}
					else if (timer->Flags() & tfActive) {
						timerStateImg = "arrow.png";
						timerStateHint = tr("Timer is active.");
					}

  reply.out() << _tntChunks[18]; // \t\t\t\t<tr>\n\n\t\t\t\t<td class="leftcol 
#line 155 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[19]; // "><img src="
#line 155 "timers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", timerStateImg) );
  reply.out() << _tntChunks[20]; // " alt="" 
#line 155 "timers.ecpp"
 if (!timerStateHint.empty()) { 
  // <& tooltip.hint ...
  { 
#line 155 "timers.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 155 "timers.ecpp"
    _tnt_cq5.add( "text", (timerStateHint));
#line 155 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq5);
    // &>
  }
#line 155 "timers.ecpp"
 } 
  reply.out() << _tntChunks[21]; // ></img></td>\n\t\t\t\t\t<td class="
#line 156 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[22]; // "><div class="withmargin"><a href="schedule.html\?channel=
#line 156 "timers.ecpp"
  reply.sout() << ( timer->Channel()->Number());
  reply.out() << _tntChunks[23]; // ">
#line 156 "timers.ecpp"
  reply.sout() << ( timer->Channel()->Name() );
  reply.out() << _tntChunks[24]; // </a></div></td>\n\t\t\t\t\t<td class="
#line 157 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[25]; // "><div class="withmargin nowrap">
#line 157 "timers.ecpp"
  reply.sout() << ( FormatDateTime(tr("%I:%M %p"), timer->StartTime()) );
  reply.out() << _tntChunks[26]; // </div></td>\n\t\t\t\t\t<td class="
#line 158 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[27]; // "><div class="withmargin nowrap">
#line 158 "timers.ecpp"
  reply.sout() << ( FormatDateTime(tr("%I:%M %p"), timer->StopTime()) );
  reply.out() << _tntChunks[28]; // </div></td>\n\t\t\t\t\t<td class="
#line 159 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[29]; // "><div class="withmargin"><a\n
#line 160 "timers.ecpp"
					if (!longDescription.empty()) {

  reply.out() << _tntChunks[30]; // \t\t\t\t\t\t
  // <& tooltip.hint ...
  { 
#line 161 "timers.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 161 "timers.ecpp"
    _tnt_cq6.add( "text", (longDescription));
#line 161 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 161 "timers.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 161 "timers.ecpp"
    _tnt_cq7.add( "domId", (epgEvent->Id()));
#line 161 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[31]; // \n
#line 162 "timers.ecpp"
					}

  reply.out() << _tntChunks[32]; // \t\t\t\t\t\t>
#line 163 "timers.ecpp"
  reply.sout() << ( timer->File() );
  reply.out() << _tntChunks[33]; // </a></div>\n\t\t\t\t\t</td>\n\t\t\t\t\t<td class="
#line 165 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[34]; // "><div class="withmargin">
#line 165 "timers.ecpp"
  reply.sout() << ( timer->Local()?trVDR(" "):timer->Remote() );
  reply.out() << _tntChunks[35]; // </div></td>\n                                        <td class="
#line 166 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[36]; // "><div class="withmargin">\n
#line 167 "timers.ecpp"
					if ( !timer->Local()) {

  reply.out() << _tntChunks[37]; //                                         
#line 168 "timers.ecpp"
  reply.sout() << ( searchTimName );
  reply.out() << _tntChunks[38]; // </div></td>\n
#line 169 "timers.ecpp"
					} else {

  reply.out() << _tntChunks[39]; // \t\t\t\t\t<a href="edit_searchtimer.html\?searchtimerid=
#line 170 "timers.ecpp"
  reply.sout() << ( searchTimId );
  reply.out() << _tntChunks[40]; // ">
#line 170 "timers.ecpp"
  reply.sout() << ( searchTimName );
  reply.out() << _tntChunks[41]; // </a></div></td>\n
#line 171 "timers.ecpp"
					}

  reply.out() << _tntChunks[42]; // \t\t\t\t        <td class="action 
#line 172 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[43]; // "><a href="timers.html\?timerid=
#line 172 "timers.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timers.GetTimerId(*timer)) );
  reply.out() << _tntChunks[44]; // &action=toggle"><img src="
#line 172 "timers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", (timer->Flags() & tfActive) ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[45]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 172 "timers.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 172 "timers.ecpp"
    _tnt_cq8.add( "text", (tr("Toggle timer active/inactive")));
#line 172 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[46]; // ></img></a></td>\n\t\t\t                <td class="action 
#line 173 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[47]; // ">
  // <& pageelems.edit_timer ...
  { 
#line 173 "timers.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 173 "timers.ecpp"
    _tnt_cq9.add( "timerId", (timers.GetTimerId(*timer)));
#line 173 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "edit_timer"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[48]; // </td>\n\t\t\t\t        <td class="action rightcol 
#line 174 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[49]; // "><a href="timers.html\?timerid=
#line 174 "timers.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timers.GetTimerId(*timer)) );
  reply.out() << _tntChunks[50]; // &action=delete"><img src="
#line 174 "timers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[51]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 174 "timers.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 174 "timers.ecpp"
    _tnt_cq10.add( "text", (tr("Delete timer")));
#line 174 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[52]; // ></img></a></td>\n\t\t\t\t</tr>\n
#line 176 "timers.ecpp"

				}
			}

  reply.out() << _tntChunks[53]; // \t\t\t</table>\n\t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[54]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[55]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::timer_actions_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("timers::timer_actions " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 25 "timers.ecpp"
  typedef const cTimer* timer_type;
  TNT_REQUEST_PAGE_VAR(const cTimer*, timer, ());   // <%request> const cTimer* timer
  _tnt_ignore_unused<timer_type>(timer);
#line 26 "timers.ecpp"
  typedef TimerConflictNotifier timerNotifier_type;
  TNT_REQUEST_PAGE_VAR(TimerConflictNotifier, timerNotifier, ());   // <%request> TimerConflictNotifier timerNotifier
  _tnt_ignore_unused<timerNotifier_type>(timerNotifier);
#line 22 "timers.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[56]; // <a href="edit_timer.html">
#line 187 "timers.ecpp"
  reply.sout() << ( tr("New timer") );
  reply.out() << _tntChunks[57]; // </a>\n
#line 188 "timers.ecpp"
 if ( LiveFeatures< features::epgsearch >().Recent() ) {

  reply.out() << _tntChunks[58]; // <span class="sep">|</span>\n<a href="timerconflicts.html">
#line 190 "timers.ecpp"
  reply.sout() << ( tr("Timer conflicts") );
  reply.out() << _tntChunks[59]; // </a>\n
#line 191 "timers.ecpp"
 }

  // <%/cpp>
  return DEFAULT;
}

} // namespace
